//---------------------------------------------------------------------------

#include <vcl.h>

#pragma hdrstop
#include "U_ftpClient.h"
#include "U_Write.h"
#include <IniFiles.hpp>



//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    Application->OnException = MyException;

    TIniFile *Config = new TIniFile(ExtractFilePath(Application->ExeName) + "Config.ini");

    HostIP = Config->ReadString("ftpHost","ftpIp","217.24.163.11");
    PingTimeOut = Config->ReadInteger("TimeOut","PingTimeOut",5000);
    UserName = Config->ReadString("UserInfo","UserName","user");
    Passwd = Config->ReadString("UserInfo","Passwd","password");
    LocalIn = Config->ReadString("DirSettings","LocalIn","C:\Mebius\In");
    LocalOut = Config->ReadString("DirSettings","LocalOut","C:\Mebius\Out");
    RemoteIn = Config->ReadString("DirSettings","RemoteIn","in");
    RemoteOut = Config->ReadString("DirSettings","RemoteOut","out");

    delete Config;

    logFile = ExtractFilePath(Application->ExeName) + "Logs\\" + Date().FormatString("ddmmyyyy") + ".log";

    LFile.CurOp = nothing;
    LFile.FileName = "";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::IdIcmpClient1Reply(TComponent *ASender,
      const TReplyStatus &AReplyStatus)
{
    StaticText1->Caption = " ...";
    switch(AReplyStatus.ReplyStatusType){
        case rsEcho:{
            StaticText1->Caption = "  ";
            WriteToFileMsg(logFile,"           " + AnsiString(Time()) + "   \n");
            ftpConnect();
            break;
        }
        case rsError:{
            StaticText1->Caption = "  ";
            WriteToFileMsg(logFile,"           " + AnsiString(Time()) + "   \n");
            break;
        }
        case rsTimeOut:{
            StaticText1->Caption = "    TimeOut";
            WriteToFileMsg(logFile,"           " + AnsiString(Time()) + "     TimeOut\n");
            break;
        }
        case rsErrorUnreachable:{
            StaticText1->Caption = "   -  ";
            WriteToFileMsg(logFile,"           " + AnsiString(Time()) + "    -  \n");
            break;
        }
        case rsErrorTTLExceeded:{
            StaticText1->Caption = "   -    ";
            WriteToFileMsg(logFile,"           " + AnsiString(Time()) + "    -    \n");
            break;
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
    Button1->Enabled = false;
    Button2->Enabled = false;
    StaticText1->Caption = " ";
    if(!Connection){
        StaticText1->Caption = "  ftp-";
        WriteToFileMsg(logFile,AnsiString(Now()) + "   \n");
        Connection = true;
    }
    else{
        StaticText1->Caption = "";
        IdFTP1->Abort();
        IdFTP1->Quit();
        WriteToFileMsg(logFile,AnsiString(Now()) + "   \n");
        Connection = false;
        Button1Click(this);
    }
    IdIcmpClient1->ReceiveTimeout = PingTimeOut;
    IdIcmpClient1->Host = HostIP;
    IdIcmpClient1->Ping();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
    StaticText1->Caption = " ";
    if(Connection){
        IdFTP1->Abort();
        IdFTP1->Quit();
        WriteToFileMsg(logFile,AnsiString(Now()) + "   \n");
    }
    Application->Terminate();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ftpConnect()
{
    IdFTP1->Host = HostIP;
    IdFTP1->User = UserName;
    IdFTP1->Password = Passwd;
    IdFTP1->Connect();

    IdFTP1->ChangeDir("logs");
    try{
        IdFTP1->Delete(ExtractFileName(logFile));
    } catch(...){}
    IdFTP1->ChangeDirUp();

    StaticText1->Caption = "ftp- ";
    IdFTP1->ChangeDir(RemoteOut);
    StaticText1->Caption = "   ";
    TStringList *SL = new TStringList();
    IdFTP1->List(SL,"*.*",true);
    bool WasInput=false, WasOutput=false;
    if(SL->Strings[0]!="ftpd: *.*: No such file or directory"){
        LFile.CurOp = input;

        WasInput = true;
        vector<AnsiString> ftpProperties;
        ListOfWords(SL->Text,ftpProperties);
        vector<FilesAttributes> ftpFileAttr;
        ftpFilesParams(ftpProperties,ftpFileAttr);
        int FilesCount = ftpFileAttr.size();

        StaticText1->Caption = "  ,  ";

        for(int str=0; str<FilesCount; str++){
            AnsiString SF = ftpFileAttr[str].FileName;
            AnsiString DF = LocalIn + ftpFileAttr[str].FileName;
            LFile.FileName = DF;

            ProgressBar1->Position = 0;
            ProgressBar1->Max = ftpFileAttr[str].FileSize;

            int InputFilesSize = 0;
            for(unsigned int strs=0; strs<ftpFileAttr.size(); strs++){
                InputFilesSize += ftpFileAttr[strs].FileSize;
            }
            ProgressBar2->Max = InputFilesSize;

            StaticText2->Caption = "  " + SF + " " + AnsiString(ftpFileAttr[str].FileSize) + " ";
            IdFTP1->Get(SF,DF,true);
            WriteToFileMsg(logFile,"           " + AnsiString(Time()) + "   " + SF + "\n");
            IdFTP1->Delete(SF);
        }
        ProgressBar1->Max = 0;
        ProgressBar2->Max = 0;

        LFile.CurOp = nothing;
        LFile.FileName = "";

        StaticText1->Caption = "  ";
        StaticText2->Caption = "";
    }
    IdFTP1->ChangeDirUp();
    IdFTP1->ChangeDir(RemoteIn);
    StaticText1->Caption = "   ";
    SL->Clear();

    vector<FilesAttributes> LocalFileAttr;
    GetDirFilesList(LocalFileAttr,LocalOut);

    if(LocalFileAttr.size()){
        LFile.CurOp = output;

        WasOutput=true;
        int FilesCount = LocalFileAttr.size();
        StaticText1->Caption = "  ,  ";
        for(int str=0; str<FilesCount; str++){
            AnsiString SF = LocalOut + LocalFileAttr[str].FileName;
            AnsiString DF = LocalFileAttr[str].FileName;
            StaticText2->Caption = "  " + LocalFileAttr[str].FileName + " " + AnsiString(LocalFileAttr[str].FileSize) + " ";

            LFile.FileName = DF;

            ProgressBar1->Position = 0;
            ProgressBar1->Max = LocalFileAttr[str].FileSize;

            int InputFilesSize = 0;
            for(unsigned int strs=0; strs<LocalFileAttr.size(); strs++){
                InputFilesSize += LocalFileAttr[strs].FileSize;
            }
            ProgressBar2->Max = InputFilesSize;

            IdFTP1->Put(SF,DF,false);
            WriteToFileMsg(logFile,"           " + AnsiString(Time()) + "   " + SF + "\n");
            DeleteFile(SF);
        }
        ProgressBar1->Max = 0;
        ProgressBar2->Max = 0;

        LFile.CurOp = nothing;
        LFile.FileName = "";
    }
    StaticText1->Caption = " -";
    IdFTP1->ChangeDirUp();
    IdFTP1->ChangeDir("logs");
    IdFTP1->Put(logFile,ExtractFileName(logFile),false);

    StaticText1->Caption = " ";
    Application->Title = "BIG_ftp";
    if(!WasInput && !WasOutput) StaticText1->Caption = StaticText1->Caption + ",    ";
    StaticText2->Caption = "";

    delete SL;

    IdFTP1->Quit();
    WriteToFileMsg(logFile,AnsiString(Now()) + "  \n");
    Button1->Enabled = true;
    Button2->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::IdFTP1Status(TObject *axSender,
      const TIdStatus axStatus, const AnsiString asStatusText)
{
    WriteToFileMsg(logFile,"           " + AnsiString(Time()) + " " + asStatusText + "\n");

}
//---------------------------------------------------------------------------


void __fastcall TForm1::IdFTP1Disconnected(TObject *Sender)
{
    Connection = false;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::GetDirFilesList(vector<FilesAttributes> &LocalFiles, AnsiString DirName)
{
    TSearchRec sr;
    if(!DirName.IsEmpty()){
        if(!FindFirst(DirName+"*.*",faAnyFile,sr))
            do{
                if (!(sr.Name=="." || sr.Name==".."))//   
                    if (((sr.Attr & faDirectory) != faDirectory ) ||
                       (sr.Attr != faDirectory))//  
                    {
                        LocalFiles.push_back();
                        LocalFiles[LocalFiles.size()-1].FileName = sr.Name;
                        LocalFiles[LocalFiles.size()-1].FileSize = FileSizeByName(DirName + sr.Name);
                    }
            }
            while (!FindNext(sr));//     
        FindClose(sr);
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ListOfWords(AnsiString String, vector<AnsiString> & strVector)
{
    if(String.IsEmpty()) return;
    bool WasSpace=false;
    AnsiString Symbol;
    strVector.push_back();
    for(int SymbNumber=1;SymbNumber<String.Length()+1;SymbNumber++){
        Symbol = String.SubString(SymbNumber,1);
        if(Symbol=="\n" || Symbol=="\r"){
            if(Symbol=="\r") strVector.push_back();
            continue;
        }
        if(Symbol==" "){
            if(!WasSpace){
                WasSpace=true;
                strVector.push_back();
            }
            continue;
        }
        else{
            WasSpace=false;
            strVector[strVector.size()-1]+=Symbol;
        }
    }
    strVector.pop_back();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ftpFilesParams(vector<AnsiString> strVector,
                                 vector<FilesAttributes> & ftpFiles)
{
    if(!strVector.size()) return;
    ftpFiles.push_back();
    for(int strs=4,VecSize=strVector.size(),Increment=4,filesCount=1;strs<VecSize;strs += Increment){
        if(Increment==5 || strs==4){
            ftpFiles[filesCount-1].FileSize = strVector[strs].ToInt();
            Increment = 4;
        }
        else{
            ftpFiles[filesCount-1].FileName = strVector[strs];
            Increment = 5;
            filesCount++;
            ftpFiles.push_back();
        }
    }
    ftpFiles.pop_back();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::IdFTP1Work(TObject *Sender, TWorkMode AWorkMode,
      const int AWorkCount)
{
    Application->ProcessMessages(); //    

    ProgressBar2->Position += AWorkCount - ProgressBar1->Position;
    ProgressBar1->Position = AWorkCount;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
    if(Connection) CanClose=false;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::MyException(TObject * Sender, Exception * E)
{
    Connection=false;
    WriteToFileMsg(logFile,"           " + AnsiString(Time()) + " Error: " + E->Message + "\n");
    Button2->Enabled = true;
    if(IdFTP1->Connected()){
        IdFTP1->Abort();
        IdFTP1->Quit();
        WriteToFileMsg(logFile,AnsiString(Now()) + "   - \n");
    }
}
//---------------------------------------------------------------------------
