//---------------------------------------------------------------------------

#ifndef U_ftpClientH
#define U_ftpClientH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <IdBaseComponent.hpp>
#include <IdComponent.hpp>
#include <IdIcmpClient.hpp>
#include <IdRawBase.hpp>
#include <IdRawClient.hpp>
#include <IdFTP.hpp>
#include <IdTCPClient.hpp>
#include <IdTCPConnection.hpp>
#include <ComCtrls.hpp>
#include <vector.h>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
//---------------------------------------------------------------------------
enum CurrentOperation {input, output, nothing};
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TIdIcmpClient *IdIcmpClient1;
    TButton *Button1;
    TButton *Button2;
    TIdFTP *IdFTP1;
    TStaticText *StaticText1;
    TStaticText *StaticText2;
    TProgressBar *ProgressBar1;
    TProgressBar *ProgressBar2;
    TImage *Image1;
    TLabel *Label1;
    void __fastcall IdIcmpClient1Reply(TComponent *ASender,
          const TReplyStatus &AReplyStatus);
    void __fastcall Button1Click(TObject *Sender);
    void __fastcall Button2Click(TObject *Sender);
    void __fastcall IdFTP1Status(TObject *axSender,
          const TIdStatus axStatus, const AnsiString asStatusText);
    void __fastcall IdFTP1Disconnected(TObject *Sender);
    void __fastcall IdFTP1Work(TObject *Sender, TWorkMode AWorkMode,
          const int AWorkCount);
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
private:	// User declarations
    AnsiString HostIP, UserName, Passwd;
    AnsiString LocalIn, LocalOut, RemoteIn, RemoteOut;
    int PingTimeOut;

    struct FilesAttributes{
        int FileSize;
        AnsiString FileName;
    };
    void __fastcall ftpConnect();
    void __fastcall GetDirFilesList(vector<FilesAttributes> &LocalFiles, AnsiString DirName);
    void __fastcall ListOfWords(AnsiString String, vector<AnsiString> & strVector);
    void __fastcall ftpFilesParams(vector<AnsiString> strVector, vector<FilesAttributes> & ftpFiles);
    void __fastcall MyException(TObject * Sender, Exception * E);
public:		// User declarations
    __fastcall TForm1(TComponent* Owner);

    struct LastFile{
        CurrentOperation CurOp;
        AnsiString FileName;
    };
    LastFile LFile;
    AnsiString logFile;
    bool Connection;

    

};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
